/*
 * include/asm-microblaze/current.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License. See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2008 Michal Simek
 * Copyright (C) 2008 PetaLogix
 * Copyright (C) 2006 Atmark Techno, Inc.
 */

#ifndef _ASM_MICROBLAZE_CURRENT_H
#define _ASM_MICROBLAZE_CURRENT_H

#include <linux/autoconf.h>

#include <asm/macrology.h>

/* The size allocated for kernel stacks.  This _must_ be a power of two!  */
#define KERNEL_STACK_SIZE	0x2000

/* Register used to hold the current task pointer while in the kernel.
Any `call clobbered' register without a special meaning should be OK,
but check asm/microblaze/kernel/entry.S to be sure.  */
#define CURRENT_TASK_REGNUM	31
#define CURRENT_TASK 		macrology_paste (r, CURRENT_TASK_REGNUM)
#ifndef __ASSEMBLY__
/* A pointer to the current task. */
register struct task_struct *current 
		__asm__ (macrology_stringify (CURRENT_TASK)); 
#define get_current() current
#endif

/* The alignment of kernel stacks, with task structures at their base.
   Thus, a pointer for a task's task structure can be derived from its
   kernel stack pointer.  */
#define CURRENT_TASK_ALIGNMENT	KERNEL_STACK_SIZE
#define CURRENT_TASK_MASK	(-CURRENT_TASK_ALIGNMENT)

#ifdef __ASSEMBLY__

/* Return the current task pointer into the specified register */
#define RETRIEVE_CURRENT_TASK(reg)			\
	add	reg, r0, CURRENT_TASK;	

/* Return the current task pointer into the specified register - physical address */
#define RETRIEVE_CURRENT_TASK_TOPHYS(reg)		\
	addi	reg,CURRENT_TASK,TOPHYS(0);
#define UPDATE_CURRENT_TASK_FROM(addr)			\
	lwi	CURRENT_TASK, r0, addr;

#endif /* __ASSEMBLY__ */

#endif /* _ASM_MICROBLAZE_CURRENT_H */
