/*
 * include/asm-microblaze/stat.h
 *
 * Microblaze stat structure
 *
 * Copyright (C) 2001,02,03 NEC Electronics Corporation
 * Copyright (C) 2001,02,03 Miles Bader <miles@gnu.org>
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License. See the file COPYING in the main directory of this
 * archive for more details.
 *
 * Written by Miles Bader <miles@gnu.org>
 */

#ifndef _ASM_MICROBLAZE_STAT_H
#define _ASM_MICROBLAZE_STAT_H

#include <asm/posix_types.h>

struct stat {
	unsigned int	st_dev;
	unsigned long	st_ino;
	unsigned int	st_mode;
	unsigned int	st_nlink;
	unsigned int	st_uid;
	unsigned int	st_gid;
	unsigned int	st_rdev;
	unsigned long	st_size;
	unsigned long	st_blksize;
	unsigned long	st_blocks;
	unsigned long	st_atime;
	unsigned long	__unused1; /* unsigned long  st_atime_nsec */ 
	unsigned long	st_mtime;
	unsigned long	__unused2; /* unsigned long  st_mtime_nsec */
	unsigned long	st_ctime;
	unsigned long	__unused3; /* unsigned long  st_ctime_nsec */
	unsigned long	__unused4;
	unsigned long	__unused5;
};

/* FIXME */
struct stat64 {
	unsigned long long	st_dev;		/* Device.  */
	unsigned long long	st_ino;		/* File serial number.  */
	unsigned int		st_mode;	/* File mode.  */
	unsigned int		st_nlink;	/* Link count.  */
	unsigned int		st_uid;		/* User ID of the file's owner.  */
	unsigned int		st_gid;		/* Group ID of the file's group. */
	unsigned long long	st_rdev;	/* Device number, if device.  */
	unsigned short		__pad2;
	long long		st_size;	/* Size of file, in bytes.  */
	int			st_blksize;	/* Optimal block size for I/O.  */
	long long		st_blocks;	/* Number 512-byte blocks allocated. */
	int			st_atime;	/* Time of last access.  */
	unsigned int		st_atime_nsec;
	int			st_mtime;	/* Time of last modification.  */
	unsigned int		st_mtime_nsec;
	int			st_ctime;	/* Time of last status change.  */
	unsigned int		st_ctime_nsec;
	unsigned int		__unused4;
	unsigned int		__unused5;
};

#endif /* _ASM_MICROBLAZE_STAT_H */
